/* 
 * File:   BMP180.h
 */

#ifndef BMP180_H
#define	BMP180_H

/** I N C L U D E S **********************************************************/
#include <pic18f87k22.h>

/** BMP180 ADDRESS DEFINITION ************************************************/
#define BMP180_ADDRESS_R 0xEF          // I2C address of BMP085 (Read)
#define BMP180_ADDRESS_W 0xEE          // I2C address of BMP085 (Write)

/** P R O T O T Y P E S ******************************************************/
short Read_int_BMP180(unsigned char rom_code0, unsigned char rom_code1);
unsigned short Read_Uint_BMP180(unsigned char rom_code0, unsigned char rom_code1);
char Read_byte_BMP180(unsigned char rom_code0);
long Read_UT_BMP180(void);
long Read_UP_BMP180(short OSS);
void Write_BMP180(unsigned char addr, unsigned char data);
long Get_True_Temp(long UT);
long Get_True_Pres(long up);
float bmp085_Altitude(float pressure, float Psea);
void Get_CalValue_BMP180(void);
void Read_Dev_BMP180(void);

#endif	/* BMP180_H */

