/*********************************************************************
 *
 *                 DS18B20 Communication Protocol
 *
 *********************************************************************
 * FileName:        DS18B20.c
 ********************************************************************/

/****** I N C L U D E S **********************************************************/

#include <xc.h>
#include <stdio.h>
#include "1wire.h"
#include <plib/delays.h>
#include <pic18f87k22.h>
#include "delay.h"
#include "DS18B20.h"

#define _XTAL_FREQ 4000000

//Varialbes para el clculo de la temperatura
//float Temperatura;
extern char TxdataDS18B20[5];
char temp_lsb,temp_msb;
unsigned char Data_DS18B20[10];
int k;
char dat[9];
int temp;
int temp_c;

void Setup_1_wire_port(void) {
    
    OW_PIN_DIRECTION = 0;
    OW_WRITE_PIN = 1;
    __delay_us(500);
}

void Off_1_wire_port(void) {
    OW_PIN_DIRECTION = 0;
    OW_WRITE_PIN = 0;
}

void ReadTemp_DS18B20(void) {

    //Comunicacin con sensor
    if (!Detect_Slave_Device()) { // Deteccin dispositivo
        
        sprintf(TxdataDS18B20, "0;"); //Envio un 0 si no se encuentra dispositivo
    } else {

        OW_write_byte(0xCC); //Acceso a Scratchpad del sensor DS18B20
        OW_write_byte(0x44); //Inicia conversin temperatura
        Delay_Sec(1); //Espera aprox 750ms de tiempo de conversin 12 bits
        OW_reset_pulse();
        OW_write_byte(0xCC); //Acceso a Scratchpad del sensor DS18B20
        OW_write_byte(0xBE);

        //Obtenemos los daots del Scratchpad del sensor DS18B20
        for (k = 0; k < 9; k++) {
            Data_DS18B20[k] = OW_read_byte();
        }
        //Los datos de la temperatura ests en los dos primeros bytes recibidos

        temp_msb = Data_DS18B20[1]; // Sign byte + lsbit
        temp_lsb = Data_DS18B20[0]; // Temp data plus lsb

        temp = ((temp_msb) << 8) + temp_lsb;
       
        //Para enviar al labview
        //ATENCIN: en labview hay que dividir por 16 el nmero que se recibe
        sprintf(TxdataDS18B20, "%d;", temp);

    }
}
unsigned char Detect_Slave_Device(void)
{
	if (!OW_reset_pulse())
		return 1;
	else 		
		return 0;
}