
#ifndef DS18B20_H
#define	DS18B20_H
/** I N C L U D E S **********************************************************/
#include <pic18f87k22.h>
#include "1wire.h"

/** P R O T O T Y P E S ******************************************************/
void Setup_1_wire_port(void);
void Off_1_wire_port(void);
void ReadTemp_DS18B20(void);
unsigned char Detect_Slave_Device(void);

/*****************************************************************************
   V A R I A B L E S
******************************************************************************/
//Function Commands para el sensor DS18B20
#define Convert_T          0x44;
#define Write_ScratchPad   0x4E;
#define Read_ScratchPad    0xBE;
#define Copy_ScratchPad    0x48;
#define Recall             0xB8;
#define Read_Power_Suply   0xB4;

//Roms Commands
#define Skip_Rom           0xCC;
#define Search_Rom         0xF0;
#define Read_Rom           0x33;
#define Define_Rom         0x55;
#define Alarm_Search       0xEC;

#endif	/* DS18B20_H */

